/***************************************************
* C source with CCS
*  File Name: 20160111_K440_MK318C_322.c
*  Rev: 1.0
*  COPYRIGHT 2016 MYCOMKITS.COM, owned by CNET LIMITED
**************************************************
*/
// include headre file
#include   <10f322.h>
#DEVICE ADC=8
// settings
#fuses   INTRC, PUT, NOLVP, NOBROWNOUT, NOWDT, NOPROTECT, NOMCLR, NODEBUG
#use delay(CLOCK = 4000000)
//
#define relay PIN_A0
#define mode PIN_A3
//
#byte WPUA = 0x09
#byte OPTION_REG = 0x0E
// variables
int value_setting = 0;  // 0 to 255
int value_sensor = 0;
int hyste = 0;
// prototyping
#separate
void get_setting();
#separate
void get_sensor();
#separate
void initializing();
// main
void main()
{
    initializing();   //
    // main loop
    while(1)
    {
        get_setting();  // get 0 to 255
        get_sensor();
        //
        if(input(mode) == 0)    // 0 = dark
        {
            if(value_sensor >= value_setting)
            {
                output_high(relay);
                hyste = 50;
            }
            else if(hyste == 0)
            {
                output_low(relay);	// Relay off
            }
        }
        else    // 1 = day
        {
            if(value_sensor < value_setting)
            {
                output_high(relay);
                hyste = 50;
            }
            else if(hyste == 0)
            {
                output_low(relay);	// Relay off
            }
        }
    }
}
//
#separate
void initializing()
{
    set_tris_a(0x0E);   //A0 output, A1, 2, 3 input
    //
    output_low(relay);   //relay off
    // A/D converter initialize AN1
    setup_adc_ports(sAN1 | sAN2);   // gnd to 5v
    setup_adc(ADC_CLOCK_DIV_2);         // 2usec
    //
    OPTION_REG = OPTION_REG & 0x7F; // enable pull up
    WPUA = 0x0F;
    // timer 0 intialize for hysteresis count down
    setup_timer_0(T0_INTERNAL|T0_DIV_256);  // 1usec,256us
    set_timer0(0xEC);              // timer 0 setting almost 5msec
    enable_interrupts(INT_TIMER0);   // timer 1 enable
    enable_interrupts(GLOBAL);       // global enable
}
//
#separate
void get_setting()
{
    set_adc_channel(2);   //must wait 65u
    delay_us(100);
    value_setting=read_adc();   // 0 to 255, 0V to 5V
}
//
#separate
void get_sensor()
{
    set_adc_channel(1);   //must wait 65u
    delay_us(100);
    value_sensor=read_adc();   // 0 to 255, 0V to 5V
}
// timer0 hysteresis count down
#int_timer0
void isr0(void)
{
    set_timer0(0xEC);             // timer 0 almost 5msec
    //
    if(hyste > 1) hyste = hyste - 1;
    else hyste = 0;
}


